/*
 * NtofLibException.h
 *  General exception object for NTOF
 *  Created on: Oct 13, 2014
 *      Author: mdonze
 */

#ifndef NTOFLIBEXCEPTION_H_
#define NTOFLIBEXCEPTION_H_

#include <string>

namespace ntof {
namespace lib {
/**
 * \class NtofLibException
 * \brief Represents an exception generated by NTOF
 */
class NtofLibException : public std::exception
{
public:
    /**
     * \brief Constructs this
     * \param Msg Error message
     * \param file Name of the file where the exception is thrown (__FILE__)
     * \param Line Line of code doing the error (__LINE__)
     */
    NtofLibException(const std::string &Msg, const std::string &file, int Line);

    /**
     * \brief Construct this
     * \param Msg Error message
     * \param file Name of the file where the exception is thrown (__FILE__)
     * \param Line Line of code doing the error (__LINE__)
     */
    NtofLibException(const char *Msg, const std::string &file, int Line);

    /**
     * \brief Construct this
     * \param Msg Error message
     * \param file Name of the file where the exception is thrown (__FILE__)
     * \param Line Line of code doing the error (__LINE__)
     * \param error Error code
     */
    NtofLibException(const char *Msg,
                     const std::string &file,
                     int Line,
                     int error);

    /**
     * \brief Empty constructor of the class
     */
    NtofLibException();

    /**
     * \brief Destructor of the class
     */
    virtual ~NtofLibException() throw();

    /**
     * \brief Overload of std::exception
     * \return Return the error message
     */
    virtual const char *what() const throw();

    /**
     * \brief Gets the error message
     * \return Return the error message
     */
    const char *getMessage() const throw();

    /**
     * \brief Gets the error code
     * \return
     */
    int getErrorCode() const throw();

    /**
     * \brief Gets the source file
     * \return Source file name
     */
    const std::string getFile() const throw();

    /**
     * \brief Gets the line in source file
     * \return Return the line in source file
     */
    int getLine() const throw();

protected:
    std::string msg;   //!< Error message
    std::string file_; //!< Source file where the exception is throw
    int line;          //!< Line of the error
    int errorCode;     //!< Error code
};
} // namespace lib
} // namespace ntof

#endif /* NTOFLIBEXCEPTION_H_ */
